int LIGHTPIN1 = A3; //My pins that the phototransistors are connected to
int LIGHTPIN2 = A4;

int FLASHPIN = 6; //The pin the LED is connected to

int THRESHHOLD = 700; /*The brightness-threshhold, generally the value with environmental brightness never goes above 600,
  so if it dips below 700 a laser probably isn't shining on a phototransistor
*/

bool go = false; //Code-Control Booleans
bool program = true;
bool start = false;

float time_1, time_2, vel; //Different float values that I use repeatedly
float DIST = 0.94; //Distance between lasers in meters


//Setup block where the communication frequency is established and an output-pin is determined
void setup() {

  Serial.begin(9600); //Standard frequency for Serial communication, same as the one on Processing
  pinMode(FLASHPIN, OUTPUT);

}

//The loop function is repated over and over again and is where the speed is measured. The repetitions allow us to keep measuring if the lasers were interrupted
void loop() {
  if ( program == true) {
    int pinValue1, pinValue2;

    //Assigns the value the Arduino measures from the first phototransistor representing the voltage to pinValue1
    pinValue1 = analogRead((LIGHTPIN1));
    //Serial.print((String)Pinvalue1 + "       "); Diagnosticcode

    //Assigns the value the Arduino measures from the second phototransistor representing the voltage to pinValue2
    pinValue2 = analogRead((LIGHTPIN2));
    //Serial.println((String)Pinvalue2); Diagnosticcode

    //These if-Statements control whether or not the time is measured and when its stopped by changing the value of go, depenign on whether or not the pinvalues dip below the threshhold.
    if (pinValue1 < THRESHHOLD && pinValue2 > THRESHHOLD)  go = true; //Checks if the first laser was interrupted by an object passing through
    if (pinValue2 < THRESHHOLD && pinValue1 > THRESHHOLD) go = false; //Checks if the second laser was interrupted by an object passing through

    if (go == true  && start == false) { //Measures the time where the first laser is broken, and saves it
      time_1 = millis(); //Saves time since the start of the program
      start = true; //Setup for measuring when the second laser is broken
    }

    /*if (go == true) { //Codeblock useful for diagnostics

      Serial.println(String(1));


      }


      if (go == false) {
      Serial.println(String(0));

      }
    */



    /*In this codeblock the if-Statement tests the booleans which indicate that the first and second lasers have both been interrupted,
      after which it measures the time where this is true, and then subtracts the first measured time from it to get the time an object took to go through both lasers.
      Then the distance between the two lasers is divided by the time to give the velocity. */

    if (go != true && start == true) {
      time_2 = (millis()); //Checks and stores how much time has passed since the beginning
      //Serial.println(time_1); //diagnostics code
      //Serial.println(time_2);
      float timedif = (time_2 - time_1) / 1000; //The difference between the two times is the time an object took to go through the entire contraption. Dividing by 1000 to go from ms to s.
      //Serial.println(timedif);
      vel = ((DIST / timedif)); //Using classic v = s/t formula to calculate speed
      Serial.println(String(vel)); //Prints vel so we can see it and Processing can pick up on it
      if (vel > 0.1) { //Short flash with the LED if the speed is above a certain, established value
        digitalWrite(FLASHPIN, HIGH);   //Turns the LED on
        delay(100);
        digitalWrite(FLASHPIN, LOW);    //turn the LED off by making the voltage LOW
        delay(100);
      }
      program = false; //Ends the speed-measurement program
    }
  }
  else if (program == false) { //Keeps printing the velocity so we can see it and Processing can pick up on it if necessary
    Serial.println( String(vel));
  }
}
